function varargout = oscilloscope(varargin)
% OSCILLOSCOPE MATLAB code for oscilloscope.fig
%      OSCILLOSCOPE, by itself, creates a new OSCILLOSCOPE or raises the existing
%      singleton*.
%      OSCILLOSCOPE tool was developed for demonstration of
%      signal visualization with an oscilloscope 
%      The routine should be used together with WAVEFORM_GEN tool. However,
%      it might work for any signal stored in the workspace as "waveform"
%      *************************************************************************
%      INPUT DATA 
%      waveform     -> the routine requires an exhisting waveform, if no
%                   waveform is available an error message is shown
%      *************************************************************************
%      OUTPUT DATA
%      -- 
%      *************************************************************************
%      HOW TO USE THE GUI TOOL?
%      1) Open the file "oscilloscope.m" in the matlab editor
%      2) Press run (or F5) to start the GUI
%      3) Press ON to show the waveform on the oscilloscope screen. OBS: while 
%      switched on the routine blocks any matlab operation (e.g.: open file
%      or run any other routine). If the user needs to open or run any
%      application it is necessary to switch off the ON button
%      4) The check box "View NonConditioned Signal" allows the user to
%      visualize the original signal from the wavegenerator. Thus, one can
%      observe how conditioning affects the signal
%      *************************************************************************
%      H = OSCILLOSCOPE returns the handle to a new OSCILLOSCOPE or the handle to
%      the existing singleton*.
%
%      OSCILLOSCOPE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in OSCILLOSCOPE.M with the given input arguments.
%
%      OSCILLOSCOPE('Property','Value',...) creates a new OSCILLOSCOPE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before oscilloscope_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to oscilloscope_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help oscilloscope
% Created by I. B. de Paula, PUC-Rio 2017
% Last Modified by GUIDE v2.5 17-Aug-2017 14:41:24

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @oscilloscope_OpeningFcn, ...
                   'gui_OutputFcn',  @oscilloscope_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before oscilloscope is made visible.
function oscilloscope_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to oscilloscope (see VARARGIN)

% Choose default command line output for oscilloscope
handles.output = hObject;
%text(-0.08,0.35,'AMPLITUDE','rotation',90,'fontsize',16,'color','k','parent',handles.axes1);
%text(0.4,-0.08,'TIME','fontsize',16,'color','k','parent',handles.axes1);
grid(handles.axes1,'on')
set(handles.axes1,'color','k','xcolor',[0.2 0.2 0.2],'ycolor',[0.2 0.2 0.2],'yticklabel',[]);
tmp=imread('knob.tif');
imshow(tmp,'parent',handles.axes3);
imshow(tmp,'parent',handles.axes4);
imshow(tmp,'parent',handles.axes5);
handles.tbase=1;
% Update handles structure
set(handles.axes5,'Visible','off');
guidata(hObject, handles);

% UIWAIT makes oscilloscope wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = oscilloscope_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes during object creation, after setting all properties.
function trigger_CreateFcn(hObject, eventdata, handles)
% hObject    handle to trigger (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function position_CreateFcn(hObject, eventdata, handles)
% hObject    handle to position (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes during object creation, after setting all properties.
function coupling_CreateFcn(hObject, eventdata, handles)
% hObject    handle to coupling (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function delay_CreateFcn(hObject, eventdata, handles)
% hObject    handle to delay (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes during object creation, after setting all properties.
function trigger_level_CreateFcn(hObject, eventdata, handles)
% hObject    handle to trigger_level (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

%***********************************************************************
%***********************************************************************
%                              CALLBACKS
%***********************************************************************
%***********************************************************************

%***********************************************************************
%                          Oscilloscope ON
%***********************************************************************

% --- Executes on button press in on_off.
function on_off_Callback(hObject, eventdata, handles)
% hObject    handle to on_off (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.position,'Min',-1);
set(handles.position,'SliderStep',[0.02, 0.2]);
set(handles.position,'Max',1);
set(handles.delay,'Min',0);
set(handles.delay,'SliderStep',[0.01, 0.1]);
set(handles.delay,'Max',1);
set(handles.trigger_level,'Min',-1);
set(handles.trigger_level,'SliderStep',[0.005, 0.1]);
set(handles.trigger_level,'Max',1);

n_div_show=10; % number of grids shown in oscilloscope screen
vector_base=[2 4 20 40 200 400 2000 4000];
vector_ampl=[2 1 0.5 0.2 0.1 0.05 0.02 0.01]*5;
vector_orig_amp=[1 0.1 0.01]*5;

on=get(handles.on_off,'Value');
if on==1
    set(handles.on_off,'BackgroundColor',[0.6412    0.6412    0.6412]);
else
    set(handles.on_off,'BackgroundColor',[0.9412    0.9412    0.9412]);
end
count_t=0;
t=0;

if evalin('base','exist(''waveform'')')==0
    h2=msgbox('No signal available. Please generate a waveform using the tool "waveform_gen.m"');
    set(handles.on_off,'Value',0);
    set(handles.on_off,'BackgroundColor',[0.9412    0.9412    0.9412]);
else
    
    while on==1
        run_orig=get(handles.original,'Value');
        if (evalin('base','exist(''waveform_original'')')==0 & run_orig==1)
            h2=msgbox('Signal is not conditioned. Please use the signal conditioner in the program "signal_conditioner.m"');
            set(handles.original,'Value',0);
            set(handles.amp_orig1,'Visible','off');
            set(handles.amp_orig0_1,'Visible','off');
            set(handles.amp_orig10m,'Visible','off');
            set(handles.text12,'Visible','off');
        else
            
            signal=evalin('base','waveform');
            time=evalin('base','time');
            mean_sig=mean(signal);
            on=get(handles.on_off,'Value');
            base=[ get(handles.sec1,'Value') get(handles.sec0_5,'Value') get(handles.sec0_1,'Value') ...
                get(handles.sec50m,'Value') get(handles.sec10m,'Value') get(handles.sec5m,'Value') ...
                get(handles.sec1m,'Value') get(handles.sec500u,'Value')];
            ampl=[ get(handles.amp2,'Value') get(handles.amp1,'Value') get(handles.amp0_5,'Value') ...
                get(handles.amp0_2,'Value') get(handles.amp0_1,'Value') get(handles.amp50m,'Value') ...
                get(handles.amp20m,'Value') get(handles.amp10m,'Value')];
            amp_orig=[ get(handles.amp_orig1,'Value') get(handles.amp_orig0_1,'Value') ...
                get(handles.amp_orig10m,'Value') ];
            n_cycles=sum(base.*vector_base);
            ampl_range=sum(ampl.*vector_ampl);
            length_dat=length(time)/n_cycles;
            t=t+1;
            count_t=rem(t,n_cycles-1)+1;
            coupling=get(handles.coupling,'Value');
            signal_shown=signal((count_t-1)*length_dat+1:count_t*length_dat);
            mean_value=floor(abs(coupling-1.9))*mean_sig; % round towards lower integer (floor) assumes 1 only for AC
            gnd=sign(abs(coupling-2)); % 0 only for GND and 1 for AC or DC couplings
            position=get(handles.position,'Value');
            delay=get(handles.delay,'Value')*time(length_dat)/10;
            trigger=get(handles.trigger,'Value');
            if run_orig==1
                signal_original=evalin('base','waveform_original');
                signal_orig_shown=signal_original((count_t-1)*length_dat+1:count_t*length_dat);
                mean_sig_original=mean(signal_original);
                mean_val_orig=floor(abs(coupling-1.9))*mean_sig_original;
                ampl_gain_original=ampl_range/sum(amp_orig.*vector_orig_amp);
            end
            
                       
            if trigger==2
                if count_t>1 & count_t<n_cycles-1
                    signal_trig=signal((count_t-1)*length_dat+1-length_dat/2:count_t*length_dat+length_dat/2-1);
                    trigger_level=get(handles.trigger_level,'Value')*ampl_range;
                    sign_trigger=sign(trigger_level);
                    ctrl=find((signal_trig(2:end)*gnd-mean_value+position)>(trigger_level-ampl_range/20) & (signal_trig(2:end)*gnd-mean_value+position)<(trigger_level+ampl_range/20) & sign(diff(signal_trig))>=0);
                    %ctrl=find(abs(signal_trig(2:end)*gnd-mean_value+position)>(trigger_level) & sign(diff(signal_trig))>=0);
                    if isempty(ctrl)==1
                        plot(time(1:length_dat)+delay,signal_shown*gnd-mean_value+position,'-g','parent',handles.axes1);
                        
                        if run_orig==1               
                            hold(handles.axes1,'on');
                            plot(time(1:length_dat)+delay,(signal_orig_shown*gnd-mean_val_orig)*ampl_gain_original+position,'-c','parent',handles.axes1);
                            hold(handles.axes1,'off');
                        end                                       
                    else
                        signal_shown=signal((count_t-1)*length_dat+1-length_dat/2+ctrl(1):count_t*length_dat-length_dat/2+ctrl(1));
                        plot(time(1:length_dat)+delay,signal_shown*gnd-mean_value+position,'-g','parent',handles.axes1);
                        
                        if run_orig==1
                            signal_orig_shown=signal_original((count_t-1)*length_dat+1-length_dat/2+ctrl(1):count_t*length_dat-length_dat/2+ctrl(1));
                            hold(handles.axes1,'on');
                            plot(time(1:length_dat)+delay,(signal_orig_shown*gnd-mean_val_orig)*ampl_gain_original+position,'-c','parent',handles.axes1);
                            hold(handles.axes1,'off');
                        end                                       
                        
                        
                    end
                end
                
            else
                plot(time(1:length_dat)+delay,signal_shown*gnd-mean_value+position,'-g','parent',handles.axes1);
                if run_orig==1
                    signal_original=evalin('base','waveform_original');
                    signal_orig_shown=signal_original((count_t-1)*length_dat+1:count_t*length_dat);
                    mean_sig_original=mean(signal_original);
                    mean_val_orig=floor(abs(coupling-1.9))*mean_sig_original;
                    ampl_gain_original=ampl_range/sum(amp_orig.*vector_orig_amp);   
                    hold(handles.axes1,'on');
                    plot(time(1:length_dat)+delay,(signal_orig_shown*gnd-mean_val_orig)*ampl_gain_original+position,'-c','parent',handles.axes1);
                    hold(handles.axes1,'off');
                end
                
            end
            grid(handles.axes1,'on');
            set(handles.axes1,'xlim',[0 time(length_dat)],'ylim',[-ampl_range ampl_range],'color','k','xcolor',[0.2 0.2 0.2],'ycolor',[0.2 0.2 0.2],'yticklabel',[]);
            pause(0.025);
        end
    end
end
%***********************************************************************
%                          AMPLITUDE FUNCTIONS
%***********************************************************************


% --- Executes on slider movement.
function position_Callback(hObject, eventdata, handles)
% hObject    handle to position (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider





% --- Executes on selection change in coupling.
function coupling_Callback(hObject, eventdata, handles)
% hObject    handle to coupling (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns coupling contents as cell array
%        contents{get(hObject,'Value')} returns selected item from coupling


% --- Executes on button press in amp2.
function amp2_Callback(hObject, eventdata, handles)
% hObject    handle to amp2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val_amp=get(handles.amp2,'Value');
if val_amp==1
    set(handles.amp1,'Value',0);
    set(handles.amp0_5,'Value',0);
    set(handles.amp0_2,'Value',0);
    set(handles.amp0_1,'Value',0);
    set(handles.amp50m,'Value',0);
    set(handles.amp20m,'Value',0);
    set(handles.amp10m,'Value',0);
end
% Hint: get(hObject,'Value') returns toggle state of amp2


% --- Executes on button press in amp1.
function amp1_Callback(hObject, eventdata, handles)
% hObject    handle to amp1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val_amp=get(handles.amp1,'Value');
if val_amp==1
    set(handles.amp2,'Value',0);
    set(handles.amp0_5,'Value',0);
    set(handles.amp0_2,'Value',0);
    set(handles.amp0_1,'Value',0);
    set(handles.amp50m,'Value',0);
    set(handles.amp20m,'Value',0);
    set(handles.amp10m,'Value',0);
end

% Hint: get(hObject,'Value') returns toggle state of amp1


% --- Executes on button press in amp0_5.
function amp0_5_Callback(hObject, eventdata, handles)
% hObject    handle to amp0_5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val_amp=get(handles.amp0_5,'Value');
if val_amp==1
    set(handles.amp2,'Value',0);
    set(handles.amp1,'Value',0);
    set(handles.amp0_2,'Value',0);
    set(handles.amp0_1,'Value',0);
    set(handles.amp50m,'Value',0);
    set(handles.amp20m,'Value',0);
    set(handles.amp10m,'Value',0);
end

% Hint: get(hObject,'Value') returns toggle state of amp0_5


% --- Executes on button press in amp0_2.
function amp0_2_Callback(hObject, eventdata, handles)
% hObject    handle to amp0_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val_amp=get(handles.amp0_2,'Value');
if val_amp==1
    set(handles.amp2,'Value',0);
    set(handles.amp1,'Value',0);
    set(handles.amp0_5,'Value',0);
    set(handles.amp0_1,'Value',0);
    set(handles.amp50m,'Value',0);
    set(handles.amp20m,'Value',0);
    set(handles.amp10m,'Value',0);
end

% Hint: get(hObject,'Value') returns toggle state of amp0_2


% --- Executes on button press in amp0_1.
function amp0_1_Callback(hObject, eventdata, handles)
% hObject    handle to amp0_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val_amp=get(handles.amp0_1,'Value');
if val_amp==1
    set(handles.amp2,'Value',0);
    set(handles.amp1,'Value',0);
    set(handles.amp0_5,'Value',0);
    set(handles.amp0_2,'Value',0);
    set(handles.amp50m,'Value',0);
    set(handles.amp20m,'Value',0);
    set(handles.amp10m,'Value',0);
end
% Hint: get(hObject,'Value') returns toggle state of amp0_1


% --- Executes on button press in amp50m.
function amp50m_Callback(hObject, eventdata, handles)
% hObject    handle to amp50m (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val_amp=get(handles.amp50m,'Value');
if val_amp==1
    set(handles.amp2,'Value',0);
    set(handles.amp1,'Value',0);
    set(handles.amp0_5,'Value',0);
    set(handles.amp0_2,'Value',0);
    set(handles.amp0_1,'Value',0);
    set(handles.amp20m,'Value',0);
    set(handles.amp10m,'Value',0);
end
% Hint: get(hObject,'Value') returns toggle state of amp50m


% --- Executes on button press in amp20m.
function amp20m_Callback(hObject, eventdata, handles)
% hObject    handle to amp20m (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val_amp=get(handles.amp20m,'Value');
if val_amp==1
    set(handles.amp2,'Value',0);
    set(handles.amp1,'Value',0);
    set(handles.amp0_5,'Value',0);
    set(handles.amp0_2,'Value',0);
    set(handles.amp0_1,'Value',0);
    set(handles.amp50m,'Value',0);
    set(handles.amp10m,'Value',0);
end
% Hint: get(hObject,'Value') returns toggle state of amp20m


% --- Executes on button press in amp10m.
function amp10m_Callback(hObject, eventdata, handles)
% hObject    handle to amp10m (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val_amp=get(handles.amp10m,'Value');
if val_amp==1
    set(handles.amp2,'Value',0);
    set(handles.amp1,'Value',0);
    set(handles.amp0_5,'Value',0);
    set(handles.amp0_2,'Value',0);
    set(handles.amp0_1,'Value',0);
    set(handles.amp50m,'Value',0);
    set(handles.amp20m,'Value',0);
end
% Hint: get(hObject,'Value') returns toggle state of amp10m





%***********************************************************************
%                        TIMEBASE FUNCTIONS
%***********************************************************************

% --- Executes on button press in sec1.
function sec1_Callback(hObject, eventdata, handles)
% hObject    handle to sec1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of sec1
val_time=get(handles.sec1,'Value');
if val_time==1
    set(handles.sec0_5,'Value',0);
    set(handles.sec0_1,'Value',0);
    set(handles.sec50m,'Value',0);
    set(handles.sec10m,'Value',0);
    set(handles.sec5m,'Value',0);
    set(handles.sec1m,'Value',0);
    set(handles.sec500u,'Value',0);
end

% --- Executes on button press in sec0_5.
function sec0_5_Callback(hObject, eventdata, handles)
% hObject    handle to sec0_5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val_time=get(handles.sec0_5,'Value');
if val_time==1
    set(handles.sec1,'Value',0);
    set(handles.sec0_1,'Value',0);
    set(handles.sec50m,'Value',0);
    set(handles.sec10m,'Value',0);
    set(handles.sec5m,'Value',0);
    set(handles.sec1m,'Value',0);
    set(handles.sec500u,'Value',0);
end
% Hint: get(hObject,'Value') returns toggle state of sec0_5


% --- Executes on button press in sec0_1.
function sec0_1_Callback(hObject, eventdata, handles)
% hObject    handle to sec0_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val_time=get(handles.sec0_1,'Value');
if val_time==1
    set(handles.sec1,'Value',0);
    set(handles.sec0_5,'Value',0);
    set(handles.sec50m,'Value',0);
    set(handles.sec10m,'Value',0);
    set(handles.sec5m,'Value',0);
    set(handles.sec1m,'Value',0);
    set(handles.sec500u,'Value',0);
 end
% Hint: get(hObject,'Value') returns toggle state of sec0_1


% --- Executes on button press in sec50m.
function sec50m_Callback(hObject, eventdata, handles)
% hObject    handle to sec50m (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val_time=get(handles.sec50m,'Value');
if val_time==1
    set(handles.sec1,'Value',0);
    set(handles.sec0_5,'Value',0);
    set(handles.sec0_1,'Value',0);
    set(handles.sec10m,'Value',0);
    set(handles.sec5m,'Value',0);
    set(handles.sec1m,'Value',0);
    set(handles.sec500u,'Value',0);
end
% Hint: get(hObject,'Value') returns toggle state of sec50m


% --- Executes on button press in sec10m.
function sec10m_Callback(hObject, eventdata, handles)
% hObject    handle to sec10m (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val_time=get(handles.sec10m,'Value');
if val_time==1
    set(handles.sec1,'Value',0);
    set(handles.sec0_5,'Value',0);
    set(handles.sec0_1,'Value',0);
    set(handles.sec50m,'Value',0);
    set(handles.sec5m,'Value',0);
    set(handles.sec1m,'Value',0);
    set(handles.sec500u,'Value',0);
end
% Hint: get(hObject,'Value') returns toggle state of sec10m


% --- Executes on button press in sec5m.
function sec5m_Callback(hObject, eventdata, handles)
% hObject    handle to sec5m (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val_time=get(handles.sec5m,'Value');
if val_time==1
    set(handles.sec1,'Value',0);
    set(handles.sec0_5,'Value',0);
    set(handles.sec0_1,'Value',0);
    set(handles.sec50m,'Value',0);
    set(handles.sec10m,'Value',0);
    set(handles.sec1m,'Value',0);
    set(handles.sec500u,'Value',0);
end
% Hint: get(hObject,'Value') returns toggle state of sec5m


% --- Executes on button press in sec1m.
function sec1m_Callback(hObject, eventdata, handles)
% hObject    handle to sec1m (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val_time=get(handles.sec1m,'Value');
if val_time==1
    set(handles.sec1,'Value',0);
    set(handles.sec0_5,'Value',0);
    set(handles.sec0_1,'Value',0);
    set(handles.sec50m,'Value',0);
    set(handles.sec10m,'Value',0);
    set(handles.sec5m,'Value',0);
    set(handles.sec500u,'Value',0);
end
% Hint: get(hObject,'Value') returns toggle state of sec1m


% --- Executes on button press in sec500u.
function sec500u_Callback(hObject, eventdata, handles)
% hObject    handle to sec500u (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val_time=get(handles.sec500u,'Value');
if val_time==1
    set(handles.sec1,'Value',0);
    set(handles.sec0_5,'Value',0);
    set(handles.sec0_1,'Value',0);
    set(handles.sec50m,'Value',0);
    set(handles.sec10m,'Value',0);
    set(handles.sec5m,'Value',0);
    set(handles.sec1m,'Value',0);
end
% Hint: get(hObject,'Value') returns toggle state of sec500u



% --- Executes on slider movement.
function trigger_level_Callback(hObject, eventdata, handles)
% hObject    handle to trigger_level (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider



% --- Executes on slider movement.
function delay_Callback(hObject, eventdata, handles)
% hObject    handle to delay (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes on selection change in trigger.
function trigger_Callback(hObject, eventdata, handles)
% hObject    handle to trigger (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns trigger contents as cell array
%        contents{get(hObject,'Value')} returns selected item from trigger




%***********************************************************************
%                        CHANNEL 2 - ORIGINAL SIGNAL
%***********************************************************************


% --- Executes on button press in original.
function original_Callback(hObject, eventdata, handles)
% hObject    handle to original (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
show_original=get(handles.original,'Value');

if show_original==1
    set(handles.amp_orig1,'Visible','on');
    set(handles.amp_orig0_1,'Visible','on');
    set(handles.amp_orig10m,'Visible','on');
    set(handles.text12,'Visible','on');
else
    set(handles.amp_orig1,'Visible','off');
    set(handles.amp_orig0_1,'Visible','off');
    set(handles.amp_orig10m,'Visible','off');
    set(handles.text12,'Visible','off');
end
% Hint: get(hObject,'Value') returns toggle state of original


% --- Executes on button press in amp_orig1.
function amp_orig1_Callback(hObject, eventdata, handles)
% hObject    handle to amp_orig1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
orig_amp=get(handles.amp_orig1,'Value');
if orig_amp==1
    set(handles.amp_orig0_1,'Value',0);
    set(handles.amp_orig10m,'Value',0);
end
% Hint: get(hObject,'Value') returns toggle state of amp_orig1


% --- Executes on button press in amp_orig0_1.
function amp_orig0_1_Callback(hObject, eventdata, handles)
% hObject    handle to amp_orig0_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
orig_amp=get(handles.amp_orig0_1,'Value');
if orig_amp==1
    set(handles.amp_orig1,'Value',0);
    set(handles.amp_orig10m,'Value',0);
end
% Hint: get(hObject,'Value') returns toggle state of amp_orig0_1


% --- Executes on button press in amp_orig10m.
function amp_orig10m_Callback(hObject, eventdata, handles)
% hObject    handle to amp_orig10m (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
orig_amp=get(handles.amp_orig10m,'Value');
if orig_amp==1
    set(handles.amp_orig0_1,'Value',0);
    set(handles.amp_orig1,'Value',0);
end
% Hint: get(hObject,'Value') returns toggle state of amp_orig10m


% --- Executes during object creation, after setting all properties.
function text12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
