function varargout = waveform_gen(varargin)
% WAVEFORM_GEN MATLAB code for waveform_gen.fig
%      WAVEFORM_GEN, by itself, creates a new WAVEFORM_GEN or raises the existing
%      singleton*.
%
%      WAVEFOR_GEN tool was developed for demonstration of
%      signal analysis. It creates a waveform in the workspace for demonstration of:
%      signal visualization with osciloscope, signal conditioning using filters and ampligiers 
%      and data aquisition
%
%      *************************************************************************
%      INPUT DATA 
%      --
%      *************************************************************************
%      OUTPUT DATA
%      waveform          -> the waveform generated according to selected parameters
%      *************************************************************************
%      HOW TO USE THE GUI TOOL?
%      1) Open the file "waveform_gen.m" in the matlab editor
%      2) Press run (or F5) to start the GUI
%      3) Select wave parameters and press generate. OBS: the
%      generation is performed ONLY WHEN the GENERATE button is pressed. If
%      parameters are modified, the user must press GENERATE again
%      *************************************************************************

%      H = WAVEFORM_GEN returns the handle to a new WAVEFORM_GEN or the handle to
%      the existing singleton*.
%
%      WAVEFORM_GEN('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in WAVEFORM_GEN.M with the given input arguments.
%
%      WAVEFORM_GEN('Property','Value',...) creates a new WAVEFORM_GEN or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before waveform_gen_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to waveform_gen_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help waveform_gen
% Created by I. B. de Paula, PUC-Rio 2017
% Last Modified by GUIDE v2.5 21-Aug-2017 19:56:46

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @waveform_gen_OpeningFcn, ...
                   'gui_OutputFcn',  @waveform_gen_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before waveform_gen is made visible.
function waveform_gen_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to waveform_gen (see VARARGIN)

% Choose default command line output for waveform_gen
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes waveform_gen wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = waveform_gen_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function slider_ampl_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_ampl (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes during object creation, after setting all properties.
function slider_freq_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_freq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes during object creation, after setting all properties.
function slider_mean_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_mean (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



% --- Executes during object creation, after setting all properties.
function edit_mean_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_mean (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function slidernoise_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slidernoise (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1


% --- Executes on slider movement.
function slider_ampl_Callback(hObject, eventdata, handles)
% hObject    handle to slider_ampl (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
set(handles.slider_ampl,'Min',0);
set(handles.slider_ampl,'SliderStep',[0.01, 0.1]);
set(handles.slider_ampl,'Max',1);
ampl=get(handles.slider_ampl,'Value');
set(handles.edit1,'String',num2str(ampl));



% --- Executes on slider movement.
function slider_freq_Callback(hObject, eventdata, handles)
% hObject    handle to slider_freq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
set(handles.slider_freq,'Min',0);
set(handles.slider_freq,'SliderStep',[0.01, 0.1]);
set(handles.slider_freq,'Max',1);
ampl=get(handles.slider_freq,'Value');
set(handles.edit2,'String',num2str(ampl));




function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double


% --- Executes during object creation, after setting all properties.




function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double


% --- Executes on button press in gen.
function gen_Callback(hObject, eventdata, handles)
% hObject    handle to gen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of gen
time=0:4*pi/40000:4*pi-4*pi/40000; % assuming 2*pi=1sec
ampl=(get(handles.edit1,'String'));
if strcmp('Edit Text',ampl)==1 || isempty(ampl)==1
    ampl=0;
else
    ampl=str2num(ampl);
end
freq=(get(handles.edit2,'String'));
if strcmp('Edit Text',freq)==1 || isempty(freq)==1
    freq=0;
else
    freq=1000*str2num(freq);
end
mean_value=(get(handles.edit_mean,'String'));
if strcmp('Edit Text',mean_value)==1 || isempty(mean_value)==1
    mean_value=0;
else
    mean_value=str2num(mean_value);
end

noise_level=get(handles.slidernoise,'Value');
noise=noise_level*randn([1,length(time)]);

wave_pattern=get(handles.popupmenu1,'Value');
if wave_pattern == 1
    disp(['Square wave, Ampl= ' num2str(ampl) ', frequency (kHz)= ' num2str(freq/1000), ' ,Mean= ' num2str(mean_value)]);
    data=square(time*freq)*ampl+mean_value+noise;
elseif wave_pattern == 2
    disp(['Triangular wave, Ampl= ' num2str(ampl) ', frequency (kHz)= ' num2str(freq/1000), ' ,Mean= ' num2str(mean_value)]);
    data=sawtooth(time*freq,0.5)*ampl+mean_value+noise;  
elseif wave_pattern == 3
    disp(['Sine wave, Ampl= ' num2str(ampl) ', frequency (kHz)= ' num2str(freq/1000), ' ,Mean= ' num2str(mean_value)]);
    data=sin(time*freq)*ampl+mean_value+noise;
end
plot(time(1:end/2)/(2*pi),data(1:end/2),'-g','linewidth',2)
grid on
set(gca,'color','k','xcolor',[0.2 0.2 0.2],'ycolor',[0.2 0.2 0.2]);
if freq>64
    set(gca,'ylim',[(min(data)-0.05*abs(min(data))) 1.05*max(data+1e-8)],'xlim',[0 1/(2^(nextpow2(freq)-5)+1)]);
else
    set(gca,'ylim',[(min(data)-0.05*abs(min(data))) 1.05*max(data+1e-8)],'xlim',[0 1]);
end

if evalin('base','exist(''waveform_original'')')~=0
    assignin('base','waveform_original',data);
    assignin('base','waveform',data);
    assignin('base','time',time/(2*pi));
    if evalin('base','exist(''waveform_filt'')')~=0
        clear waveform_filt;
    end
    if evalin('base','exist(''waveform_ampl'')')~=0
        clear waveform_ampl;
    end
else
    assignin('base','waveform',data);
    assignin('base','time',time/(2*pi));
end


% --- Executes on slider movement.
function slider_mean_Callback(hObject, eventdata, handles)
% hObject    handle to slider_mean (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
set(handles.slider_mean,'Min',0);
set(handles.slider_mean,'SliderStep',[0.01, 0.1]);
set(handles.slider_mean,'Max',1);
ampl=get(handles.slider_mean,'Value');
set(handles.edit_mean,'String',num2str(ampl));


function edit_mean_Callback(hObject, eventdata, handles)
% hObject    handle to edit_mean (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_mean as text
%        str2double(get(hObject,'String')) returns contents of edit_mean as a double


% --- Executes on slider movement.
function slidernoise_Callback(hObject, eventdata, handles)
% hObject    handle to slidernoise (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
set(handles.slidernoise,'Min',0);
set(handles.slidernoise,'SliderStep',[0.01, 0.1]);
set(handles.slidernoise,'Max',1);


